#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// This indcator shows how to access Orderflow data
    /// </summary>
    [Description("This indicator shows how to access MP  exposed data")]
    public class GomTestMPLevels : Indicator
    {
 
		GomMPProLevels gmpl;

		
        protected override void Initialize()
        {
            Overlay				= false;
			BarsRequired=0;

        }

		protected override void OnStartUp()
		{
			gmpl=	GomMPProLevels(Gom.MP.DataSourceType.MinuteData, false, 0,1, Gom.MP.Periodicity.Daily, 
					"17:00:00", "09:00:00", Gom.Lib.GomTZ.TIMEZONE_LOCAL, 1,false, 70, 5,
					Gom.MP.ProfileData.Volume);	
			gmpl.CalculateOnBarClose=this.CalculateOnBarClose;

		}

        protected override void OnBarUpdate()
        {	
			//update gmpl indicator
			gmpl.Update();
			
			Print("\n"+CurrentBar+"-"+Time[0]);
			
			Print("HVNs");	
			foreach(double hvn in gmpl.VN.HVNs)
				Print(hvn);
			
			Print("LVNs");			
			foreach(double lvn in gmpl.VN.LVNs)
				Print(lvn);
						
			Print("POC");			
			Print(gmpl.POC[0]);
		}

    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private GomTestMPLevels[] cacheGomTestMPLevels = null;

        private static GomTestMPLevels checkGomTestMPLevels = new GomTestMPLevels();

        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        public GomTestMPLevels GomTestMPLevels()
        {
            return GomTestMPLevels(Input);
        }

        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        public GomTestMPLevels GomTestMPLevels(Data.IDataSeries input)
        {
            if (cacheGomTestMPLevels != null)
                for (int idx = 0; idx < cacheGomTestMPLevels.Length; idx++)
                    if (cacheGomTestMPLevels[idx].EqualsInput(input))
                        return cacheGomTestMPLevels[idx];

            lock (checkGomTestMPLevels)
            {
                if (cacheGomTestMPLevels != null)
                    for (int idx = 0; idx < cacheGomTestMPLevels.Length; idx++)
                        if (cacheGomTestMPLevels[idx].EqualsInput(input))
                            return cacheGomTestMPLevels[idx];

                GomTestMPLevels indicator = new GomTestMPLevels();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomTestMPLevels[] tmp = new GomTestMPLevels[cacheGomTestMPLevels == null ? 1 : cacheGomTestMPLevels.Length + 1];
                if (cacheGomTestMPLevels != null)
                    cacheGomTestMPLevels.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomTestMPLevels = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomTestMPLevels GomTestMPLevels()
        {
            return _indicator.GomTestMPLevels(Input);
        }

        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        public Indicator.GomTestMPLevels GomTestMPLevels(Data.IDataSeries input)
        {
            return _indicator.GomTestMPLevels(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomTestMPLevels GomTestMPLevels()
        {
            return _indicator.GomTestMPLevels(Input);
        }

        /// <summary>
        /// This indicator shows how to access MP  exposed data
        /// </summary>
        /// <returns></returns>
        public Indicator.GomTestMPLevels GomTestMPLevels(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomTestMPLevels(input);
        }
    }
}
#endregion
